/**************************************************************************/
/*                                                                        */
/* NAME:    dev1821.c                                                     */
/* OPTIONS: <port (1,2,3)>                                                */
/*                                                                        */
/* Mod History:  4/95 Modified from DS1620 DOS Demo (by JP)               */
/*               6/95 Significant cleanup and debugging (by JD)           */
/*               5/96 Modified toggle() to verify WR1/RD has completed    */
/*                       before issuing next WR1/RD (by JD                */
/*                                                                        */
/**************************************************************************/

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

typedef unsigned long ulong;

#define FALSE	0
#define TRUE	1
enum { _OFF_, _ON_ };
enum { _TH_, _TL_, _CONFIG_, _TEMP_ };
enum { _DECC_, _DECF_, _HEX_, _BIN_ };
enum { _RESET_, _WR0_, _WR1_, _RD_ };

ulong far *sysclk = (ulong far *) 0x0040006cL;
ulong M;

union REGS regs;
struct text_info scrnsave;
unsigned int cursorsave;

int p_addr;

unsigned int OUT;
unsigned int IN;
unsigned int IN_OUT;

int op_place[36][2]={
   0, 0,
   8, 5,
   8, 6,
   8, 7,
	8, 8,
	0, 0,
	0, 0,
	0, 0,
	0, 0,
	0, 0,
   20, 5,
	0, 0,
	0, 0,
   20, 8,
   16, 13,
   16, 14,
   16, 21,
   16, 22,
   0, 0,
   57, 5,
	0, 0,
	0, 0,
   57, 8,
	0, 0,
	0, 0,
   54, 21,
   54, 22,
	62, 1,
   62, 5,
   62, 6,
   62, 7,
	62, 8,
	0,  0,
	0,  0,
	62, 21,
	62, 22 };

char op_text[36][18]={
   "",
   "",
   "",
   "",
	"",
	"",
	"",
	"",
	"",
	"",
	"\036\036\036",
	"",
	"",
	"\037\037\037",
	"POWER UP MODE",
	" SWITCH MODE ",
	"  CLEAR THF  ",
	"  CLEAR TLF  ",
   "",
   "\036\036\036",
	"",
	"",
	"\037\037\037",
	"",
	"",
	" START ",
	" STOP  ",
	"  EXIT   ",
   "",
   "",
   "",
   "",
	"",
	"",
	"",
	"" };

void beep_good( void )
{
  sound(1000);
  delay(10);
  nosound();
}

void beep_bad( void )
{
  sound(100);
  delay(100);
  nosound();
}

void save_screen( void )
{
	gettextinfo( &scrnsave);
   regs.h.ah = 3;
   int86( 0x10, &regs, &regs );
   cursorsave = regs.x.cx;

   regs.h.ah = 1;
   regs.x.cx = regs.x.cx | 0x2000;
	int86( 0x10, &regs, &regs);
}

void terminate( void )
{
	regs.h.ah = 1;
	regs.x.cx = cursorsave;
	int86( 0x10, &regs, &regs );
	textattr( scrnsave.attribute );
	clrscr();
}

int send_1480( int command )
{
	M = *sysclk + 1;
	switch ( command )
		{
		case _RESET_:	outportb( OUT, 0xFD );
							break;
		case _WR0_:		outportb( OUT, 0xFE );
							break;
		case _WR1_:
		case _RD_:		outportb( OUT, 0xFF );
							break;
		}
	outportb(IN_OUT,0x04);
	outportb(IN_OUT,0x06);
	while (((inportb(IN) & 0x10) == 0x10) && (*sysclk <= M));
	outportb(OUT,0xff);
	while (((inportb(IN) & 0x10) == 0x00) && (*sysclk <= M));

	if ( command==_RESET_ )
		{
		if ( *sysclk > M )
			return FALSE;
		else
			return TRUE;
		}
	else
		{
		outportb(OUT,0xfe);
		if ( ( inportb(IN) & 0x10 ) == 0x10 )
			return 1;
		else
			return 0;
		}
}

char comm_port( char port_num )
{
	char k=-1;

	p_addr = 0;

	if ( port_num=='1' || port_num=='2' || port_num=='3' )
		{
		k=port_num;
		if ( peekb( 0, 0x408 + (port_num - '1')*2 )!=0 )
			{
			p_addr = port_num - '0';
			OUT = peek( 0, 0x0408 + (p_addr-1)*2 );
			IN     = OUT + 1;
			IN_OUT = OUT + 2;
			return 0;
			}
		}

	do {
		textcolor( WHITE );
		textbackground( BLACK );
		if ( k != -1 )
			{
			clrscr();
			gotoxy(24,12);
			cprintf( "\nParallel port LPT%c does not exist!", k );
			gotoxy(27,14);
			cprintf( "\nPress a key to continue . . ." );
			getch();
			}
		clrscr();
		gotoxy(27,11);
		cprintf( "DS1821 Development Program" );
		gotoxy(22,13);
		cprintf("Select the parallel port to be used");
		gotoxy(10,15);
		cprintf("Enter '1', '2', or '3' for port 1, 2, or 3, or 'q' to quit");

		do
			k = getch();
		while ( k!='1' && k!='2' && k!='3' && k!='q' && k!='Q' );

		if ( k=='q' || k=='Q' )
			return -1;
	} while ( peek( 0, 0x408 + ( k-'1' )*2 ) == 0 );

	p_addr = k - '0';
	OUT    = peek( 0, 0x408 + ( p_addr - 1 )*2 );
	IN     = OUT + 1;
	IN_OUT = OUT + 2;

	return 0;
}

void write_port(char *data)
{
	int index;

	for ( index = strlen( data ) - 1; index >= 0; index-- )
		if ( data[index] == '1' )
			send_1480( _WR1_ );
		else
			send_1480( _WR0_ );
}

void write_byte( int com )
{
	int i;

	for ( i = 0 ; i < 8 ; i++ )
		if ( ( com & ( 1<<i ) ) == 0 )
			send_1480( _WR0_ );
		else
			send_1480( _WR1_ );
}

int write_com( int com )
{
	if ( !send_1480( _RESET_ ) )
		return 0;
	write_byte( com );
	return 1;
}

int read_8( char *data )
{
	int index, power = 1, value = 0;

	*(data+8)='\0';

	for( index = 7; index >= 0; index--)
		{
		if( send_1480( _RD_ )==1 )
			{
			*(data+index) = '1';
			value +=power;
			}
		else
			*(data+index) = '0';
		power *= 2;
		}
	return value;
}

int rd_part( int type )
{
	char rd_data[10];
	int value = 0;

	switch ( type )
	{
	case _TEMP_:	/* Read temp  */
						if ( !write_com( 0xAA ) )
							return 0;
						break;
	case _TH_:     /*  Read th  */
						if ( !write_com( 0xA1 ) )
							return 0;
						break;
	case _TL_:     /*  Read tl  */
						if ( !write_com( 0xA2 ) )
							return 0;
						break;
	case _CONFIG_: /* Read config */
						if ( !write_com( 0xAC ) )
							return 0;
						break;
	}
 value = read_8(rd_data);
 return value;
}

/* Convert integer value to 8-bit binary string */
void int_to_8( int value, char data[] )
{
   int index, power=128, current;

   current = value % 256;
   for ( index = 0 ; index < 8 ; index++ )
      {
      data[index] = current / power + '0';
      if ( current >= power ) current -= power;
	  power /= 2;
      }
   data[8] = '\0';
}

/************************************************************************/
/* Enter data from keyboard input; values can be decimal, in deg. C or F
   (type=_DECC_ or _DECF_); hexadecimal (type=_HEX_); or binary
   (type=_BIN_).  x_pos and y_pos are screen positions.  old_value is
   the previous value.                                                   */

int input_word( int type, int x_pos, int y_pos, int old_value )
   {
   char c;
	int index=0, total=0, val, digits[10], i,
		 decimal=0, scale=10, sign=0, length=5;

   textbackground( BLACK );
   gotoxy( x_pos, y_pos );
	for ( i=0 ; i<9 ; i++ ) cputs(" ");
   textcolor( WHITE );
   textbackground( WHITE );
   gotoxy( x_pos, y_pos );
   cputs( " " );
   gotoxy( x_pos, y_pos );
   textbackground( BLACK );

   do
      {
      val=-1;
      c = toupper( getch() );

		if ( type==_HEX_ ) { scale=16; length=2; }
		else if ( type==_BIN_ ) { scale=2; length=8; }

		if ( c>='2' && c<='9' && type!=_BIN_ ) val=c-'0';
      else if ( c>='A' && c<='F' && type==_HEX_ ) val=c-'A'+10;
      else if ( c=='0' || c=='1' ) val=c-'0';

      if ( val >= 0 )
			{
			if (index<length && (index==0 || index==1 || digits[index-2]!=-2))
				{
				total = total * scale + val;
				cprintf( "%c", c );
				textbackground( WHITE );
				cputs( " " );
				textbackground( BLACK );
				digits[index++] = val;
				gotoxy( x_pos + index, y_pos );
				}
			else beep_bad();
			}
		else
			switch ( c )
				{
				case 27:  return old_value;
				case 8:   if ( index != 0 )
								{
								cputs( " " );
								if ( digits[--index] >= 0 )
									total = ( total - digits[index] ) / scale;
								else if ( digits[index] == -2 ) decimal=0;
								else if ( digits[index] == -3 ) sign=0;
								gotoxy( x_pos + index, y_pos );
								textbackground( WHITE );
								cputs( " " );
								textbackground( BLACK );
								gotoxy( x_pos + index, y_pos );
								}
								else
									beep_bad();
								break;
				case '.': if ( decimal==0 && (type==_DECC_ || type==_DECF_))
								{
								cprintf( "%c", c ); decimal=1; digits[index++]=-2;
								textbackground( WHITE );
								cputs( " " ); gotoxy( x_pos + index, y_pos );
								textbackground( BLACK );
								}
								else
									beep_bad();
								break;
				case '-': if ( index==0 && (type==_DECC_ || type==_DECF_))
								{
								cprintf( "%c", c ); sign=1; digits[index++]=-3;
								textbackground( WHITE );
								cputs( " " ); gotoxy( x_pos + index, y_pos );
								textbackground( BLACK );
								}
								else
									beep_bad();
								break;
				case 13:  break;
				default:  beep_bad();
				}
	} while ( c!=13 && c!=27 );

   if (( type==_HEX_ || type==_BIN_ ) && total > 127 )
		total -= 256;

   if (( decimal==0 || ( index > 0 && digits[index-1]==-2 ))
			&&( type==_DECC_ || type==_DECF_ ))
      total *= 10;
	if ( sign==1 ) total*=-1;
   if ( type==_DECC_ )
      {
      if ( total >= 0 ) total = (total + 5)/10;
      else total = (total - 5)/10;
      }
	else
		if ( type==_DECF_)
			{
			if ( total >= 320 ) total = ( ( (total - 320)*5 + 9)/9 + 4)/10;
			else total = -(((320 - total)*5 + 9)/9 + 4)/10;
			}
   if ( total < -128 ) total = -128;
   if ( total > 127 ) total = 127;
   if ( total < 0 ) total += 256;
	if ( index == 0 )
		return old_value;
	else
		return total;
}

void wr_part( int wr_reg, int param)
{
	char wr_data[10];

	int_to_8( param, wr_data);
	switch( wr_reg )
		{
		case _TH_:		if ( write_com( 0x01 ) )
								write_port( wr_data );
							break;
		case _TL_:		if ( write_com( 0x02 ) )
								write_port( wr_data );
							break;
		case _CONFIG_:	if ( write_com( 0x0C ) )
								write_port( wr_data );
							break;
		}
}

void toggle( void )
{
	int i;

	M = *sysclk + 1;
	outportb(IN_OUT,0x04);
	outportb(IN_OUT,0x06);
	while (((inportb(IN) & 0x10) == 0x10) && (*sysclk <= M));
	while (((inportb(IN) & 0x10) == 0x00) && (*sysclk <= M));
}

void mode( void )
{
	int n;
	outportb(OUT,0x7f);
	for ( n=0; n<18 ; n++ )
		toggle();
	outportb(OUT,0xff);
}

/************************************************************************/
/* Positions cursor at given place.  state can be either _ON_ or _OFF_. */

void draw_cursor( int place, int state )
{
   if ( state==_ON_ )
      {
      textbackground( LIGHTGRAY );
      textcolor( WHITE );
      }
   else
      {
      textbackground( BLACK );
		if (place >= 1 && place <= 13)
			textcolor( LIGHTCYAN );
		else if ((place >= 28 && place <= 31) || place==19 || place==22)
			textcolor( LIGHTRED );
		else textcolor( YELLOW );
      }

   gotoxy( op_place[place][0], op_place[place][1] );
   cputs( op_text[place] );

   textbackground( BLACK );
   textcolor( YELLOW );
}

void set_up_screen( void )
{
   textbackground( BLACK );
   textcolor( LIGHTGRAY );
   clrscr();

	gotoxy( 24, 2 );
	cprintf( "DS1821 Development Program v1.0" );

   textcolor( LIGHTCYAN );
	gotoxy( 15, 3 ); cprintf("TL");
   textcolor( LIGHTRED );
	gotoxy( 63, 3); cprintf("TH");
   textcolor( LIGHTGRAY );
   gotoxy( 32, 5 );  cprintf("125\370C      257\370F");
   gotoxy( 32, 14 ); cprintf("-55\370C      -67\370F");
   gotoxy( 6, 4 );
   cprintf( "\311\315\315\315\315\315\315\315\315\315\315\315\315\315" );
   cprintf( "\315\315\315\315\315\273" );
   gotoxy( 54, 4 );
   cprintf( "\311\315\315\315\315\315\315\315\315\315\315\315\315\315" );
   cprintf( "\315\315\315\315\315\273" );
   gotoxy( 6, 5 );
   cprintf( "\272                  \272" );
   gotoxy( 54, 5 );
   cprintf( "\272                  \272" );
   gotoxy( 6, 6 );
   cprintf( "\272                  \272" );
   gotoxy( 54, 6 );
   cprintf( "\272                  \272" );
   gotoxy( 6, 7 );
   cprintf( "\272                  \272" );
   gotoxy( 54, 7 );
   cprintf( "\272                  \272" );
   gotoxy( 6, 8 );
   cprintf( "\272                  \272" );
   gotoxy( 54, 8 );
   cprintf( "\272                  \272" );
   gotoxy( 6, 9 );
   cprintf( "\310\315\315\315\315\315\315\315\315\315\315\315\315\315" );
   cprintf( "\315\315\315\315\315\274" );
   gotoxy( 54, 9 );
   cprintf( "\310\315\315\315\315\315\315\315\315\315\315\315\315\315" );
   cprintf( "\315\315\315\315\315\274" );
   gotoxy( 14, 19 );
   cprintf( "STATUS" );
   gotoxy( 14 , 11);
   cprintf( "FUNCTION" );
   gotoxy( 64, 19 );
   cprintf( "CONFIG" );
   textcolor( WHITE );
   gotoxy( 2, 25 );
   cprintf( "Use arrow keys to move cursor.  " );
   cprintf( "Press ENTER to activate function under cursor." );

	draw_cursor( 10, _OFF_ );
	draw_cursor( 13, _OFF_ );
	draw_cursor( 14, _OFF_ );
	draw_cursor( 15, _OFF_ );
	draw_cursor( 16, _OFF_ );
	draw_cursor( 17, _OFF_ );

	draw_cursor( 19, _OFF_ );
	draw_cursor( 22, _OFF_ );
	draw_cursor( 25, _OFF_ );
	draw_cursor( 26, _OFF_ );
	draw_cursor( 27, _OFF_ );
	draw_cursor( 34, _OFF_ );
	draw_cursor( 35, _OFF_ );
}

/************************************************************************/
/* Updates temperature display.  temp is the current temperature.			*/

void thermometer( int temp )
{
   int height, i, temp_c;
   char temp_data[10];

   textcolor( RED );

   gotoxy( 39, 14 ); cprintf( "\333\333" );
   gotoxy( 38, 15 ); cprintf( "\333\333\333\333" );
   gotoxy( 39, 16 ); cprintf( "\337\337" );

   if ( temp >= 128 ) temp_c=temp-256;
   else temp_c=temp;

   height=(temp_c + 120)/20;

   for ( i = 0 ; i <= 18 ; i = i+2 )
      {
      gotoxy( 39, 14 - i/2 );
		if ( i == height )
			cprintf( "\334\334" );
		else
			if ( i < height )
				{
				textcolor(BLACK);
				textbackground(RED);
				cprintf( "\304\304" );
				textcolor(RED);
				textbackground(BLACK);
				}
				else
					cprintf( "\304\304");
		}

   textcolor( WHITE );

	gotoxy( 36, 17 );
	cprintf( " %4d C ", temp_c );

	gotoxy( 36, 19 );
	cprintf( "%6.1f F", temp_c*9.0/5.0 + 32.0 );

	gotoxy( 36, 21 );
   cprintf( "   %02Xh   ", temp );

	gotoxy( 36, 23 );
	int_to_8( temp, temp_data );
   cprintf( "%sb", temp_data );
}

/************************************************************************/
/* Updates thermostat display.  t_reg is either _TH_ or _TL_; value is
	integer value of thermostat setting.                                 */

void thermostat( int t_reg, int value )
{
   int x=8, y=5, place=1, value_c;
   char value_data[10];

   if (value >= 128) value_c=value-256;
   else value_c=value;

   if ( t_reg == _TH_ )
      {
      textcolor( LIGHTRED );
      x=62;
		place=28;
      }
   else textcolor( LIGHTCYAN );

   gotoxy( x, y );
	sprintf( op_text[place], " %4d C ", (int) value_c );
   cputs( op_text[place] );

   gotoxy( x, y+1 );
	sprintf( op_text[place+1], "%6.1f F",
      ((float) value_c)*9/5 + 32 );
   cputs( op_text[place+1] );

   gotoxy( x, y+2 );
   sprintf( op_text[place+2], "   %02Xh   ", value );
   cputs( op_text[place+2] );

   gotoxy( x, y+3 );
	int_to_8( value, value_data );
   sprintf( op_text[place+3], "%sb", value_data );
   cputs( op_text[place+3] );

   textcolor( YELLOW );
}

/**************************************************************************/
/* Updates configuration display.  config is current configuration value. */

void configuration( int config )
{
   textcolor( LIGHTGREEN );

   gotoxy( 7, 23 );
	if ( (config & 0x80) == 0x80 )
	cputs( "* DONE" );
   else cputs( "o DONE" );

   gotoxy( 7, 22 );
	if ( (config & 0x08) == 0x08 )
	cputs( "* TLF" );
   else cputs( "o TLF" );

   gotoxy( 7, 21 );
	if ( (config & 0x10) == 0x10 )
	cputs( "* THF" );
   else cputs( "o THF" );

   gotoxy( 7, 13 );
	if ( (config & 0x04) == 0x04 )
	cputs( "* T/RB" );
	else cputs( "o T/RB" );

	gotoxy( 56,13);
	cprintf("Using LPT Port %d",p_addr);

   textcolor( YELLOW );

	gotoxy( op_place[34][0], op_place[34][1] );
	if ( (config & 0x01) == 0x01 )
	sprintf( op_text[34], "* ONESHOT" );
	else sprintf( op_text[34], "o ONESHOT" );
	cputs( op_text[34] );

	gotoxy( op_place[35][0], op_place[35][1] );
	if ( (config & 0x02) == 0x02 )
	sprintf( op_text[35], "* POL    " );
	else sprintf( op_text[35], "o POL    " );
	cputs( op_text[35] );
}

/************************************************************************/
/* Moves cursor around screen and sets appropriate place.  place is the
   integer value corresponding to the current position.  returns new
   position.                                                            */

int move_cursor( int place )
{
   char c;

   draw_cursor( place, _OFF_ );
   c = getch();

   switch ( c )
      {
		case 72:
			switch ( place )
				{ /* up arrow */
				case 1:  place = 4;  break;
				case 13: place = 10; break;
				case 10: place = 17; break;
				case 19: place = 26; break;
				case 22: place = 19; break;
				case 25: place = 22; break;
				case 27: place = 35; break;
				case 34: place = 31; break;
				default: place -= 1;
				}
			break;
		case 80:
			switch ( place )
				{ /* down arrow */
				case 4:  place = 1;  break;
				case 10: place = 13; break;
				case 17: place = 10; break;
				case 19: place = 22; break;
				case 22: place = 25; break;
				case 26: place = 19; break;
				case 31: place = 34; break;
				case 35: place = 27; break;
				default: place += 1;
				}
			break;
		case 75:
			switch ( place )
				{ /* left arrow */
				case 1:  place = 28; break;
				case 2:  place = 29; break;
				case 3:  place = 30; break;
				case 4:  place = 31; break;
				case 14: place = 14; break;
				case 15: place = 15; break;
				case 16: place = 34; break;
				case 17: place = 35; break;
				case 27: place = 27; break;
				case 29: place = 19; break;
				case 30: place = 22; break;
				default: place -= 9;
				}
			break;
		case 77:
			switch ( place )
				{ /* right arrow */
				case 2:  place = 10; break;
				case 3:  place = 13; break;
				case 14: place = 14; break;
				case 15: place = 15; break;
				case 27: place = 27; break;
				case 28: place = 1;  break;
				case 29: place = 2;  break;
				case 30: place = 3;  break;
				case 31: place = 4;  break;
				case 34: place = 16; break;
				case 35: place = 17; break;
				default: place += 9;
				}
			break;
		default:
			beep_bad();
      }
   draw_cursor( place, _ON_ );
   return( place );
}

void enter_thermostat( int type, int thermostat_reg, int op, int *val )
{
	switch ( op )
		{
		case 10:
		case 19:
			if ( (*val < 127) || ((*val < 255 ) && (*val > 127 )) )
				++(*val);
			else
				if ( *val == 255 )
					*val=0;
			break;
		case 13:
		case 22:
			if ( (*val > 128) || ((*val > 0) && (*val < 128 )) )
				--(*val);
			else
				if ( *val == 0 )
					*val=255;
			break;
		default:
			*val = input_word( type, op_place[op][0], op_place[op][1], *val );
		}

	wr_part( thermostat_reg, *val );
	beep_good();
	thermostat( thermostat_reg, *val );
	delay( 200 );
	*val = rd_part( thermostat_reg );
	send_1480( _RESET_ );
	thermostat( thermostat_reg, *val );
}

void enter_config( int op, int *conf_old, int *conf_new )
{
	switch( op )
		{
		case 14:	*conf_old ^= 0x04;
					break;
		case 16:	*conf_old &= 0xEF;
					break;
		case 17:	*conf_old &= 0xF7;
					break;
		case 34:	*conf_old ^= 0x01;
					break;
		case 35:	*conf_old ^= 0x02;
					break;
		}

	*conf_new = rd_part( _CONFIG_ );
	send_1480( _RESET_ );

	if ( op==16 || op==17 )
		wr_part( _CONFIG_ , *conf_old );
	else
		wr_part( _CONFIG_ , *conf_old | 0x18 );
	beep_good();
	delay( 200 );
	write_com( 0xAF );
	send_1480( _RESET_ );
	*conf_new = rd_part( _CONFIG_ );
	send_1480( _RESET_ );
	configuration( *conf_new );
}

char switch_mode( void )
{
	char c;

	mode();
	clrscr();
	textcolor( LIGHTRED );
	gotoxy(24,10);
	cputs ("Communication to the DS1821 is off" );
	gotoxy(28,12);
	cputs( "Part is in thermostat mode" );
	gotoxy(11,14);
	cputs( "Type 'm' to toggle back to communication mode, or 'q' to quit" );
	while( ( c=getch() ) != 'm' && c != 'q' );

	return c;
}

int check_port( void )
{
	int config_val;

	config_val = rd_part( _CONFIG_ );
	send_1480( _RESET_ );
	if ( ( config_val & 0x60 ) != 0x40 )
		{
		mode();
		config_val = rd_part( _CONFIG_ );
		send_1480( _RESET_ );
		if ( ( config_val & 0x60 ) != 0x40 )
			return FALSE;
		}

	return TRUE;
}

int comm_switch( void )
{
	char e;

	clrscr();
	textcolor( LIGHTRED );
	gotoxy(24,10);
	cputs( "Communication to the DS1821 is off" );
	gotoxy(15,12);
	cputs( "(possible missing part or wrong parallel port number)" );
	gotoxy(5,14);
	cputs( "If part has been removed, then insert part and type 'c' to communicate" );
	gotoxy(13,16);
	cputs( "If wrong port, type 's' to select new parallel port number" );
	gotoxy(25,18);
	cputs( "Otherwise, press 'q' to quit" );

	do
		e = getch();
	while  ( e != 'c' && e != 's' && e != 'q' );

	return e;
}

void perform_op( int* op, int *th, int *tl,
	int *config_old, int *config_new, int* done, int* restart )
{
	char c, d;

	c = getch();

	switch (c)
		{
		case   0:
		case 224:	*op = move_cursor( *op );
						break;
		case  27:	*done = 1;
						break;
		case  13:	switch ( *op )
							{
							case 1:	/* Enter TL in deg. C */
										enter_thermostat( _DECC_, _TL_, *op, tl );
										break;
							case 2:	/* Enter TL in deg. F */
										enter_thermostat( _DECF_, _TL_, *op, tl );
										break;
							case 3:	/* Enter TL in hex    */
										enter_thermostat( _HEX_, _TL_, *op, tl );
										break;
							case 4:	/* Enter TL in binary */
										enter_thermostat( _BIN_, _TL_, *op, tl );
										break;

							case 10:	/* Increment TL */
										enter_thermostat( 0, _TL_, *op, tl );
										break;

							case 13:	/* Decrement TL */
										enter_thermostat( 0, _TL_, *op, tl );
										break;

							case 14:
							case 16:
							case 17:
							case 34:
							case 35:
										enter_config( *op, config_old, config_new );
										break;

							case 15:	/* Switch Modes - Toggle to/from one wire */
										if ( (d=switch_mode()) == 'q' || d == 'Q' )
											*done=TRUE;
										else
											{
											*restart=TRUE;
											mode();
											}
										break;

							case 19:	/* Increment TH */
										enter_thermostat( 0, _TH_, *op, th );
										break;

							case 22:	/* Decrement TH */
										enter_thermostat( 0, _TH_, *op, th );
										break;

							/* Start temperature conversion */
							case 25:	write_com( 0xEE );
										send_1480( _RESET_ );
										beep_good();
										break;

							/* Stop temperature conversion */
							case 26:	write_com( 0x22 );
										send_1480( _RESET_ );
										beep_good();
										break;

							case 27:	*done = 1;
										break;      /* Exit program */

							case 28:  /* Enter TH in deg. C */
										enter_thermostat( _DECC_, _TH_, *op, th );
										break;

							case 29:  /* Enter TH in deg. F */
										enter_thermostat( _DECF_, _TH_, *op, th );
										break;

							case 30:  /* Enter TH in hex    */
										enter_thermostat( _HEX_, _TH_, *op, th );
										break;

							case 31:  /* Enter TH in binary */
										enter_thermostat( _BIN_, _TH_, *op, th );
										break;
							}
						draw_cursor( *op, _ON_ );
						break;
		default:		beep_bad();
		}
}

int read_val( int rd_reg, int val_old )
{
	int val_new, val2_new;
	val_new = rd_part( rd_reg );
	send_1480( _RESET_ );
	if ( val_new != val_old )
		{
		val2_new = rd_part( rd_reg );
		send_1480( _RESET_ );
		}
	delay( 100 );

	if ( val_new==val2_new )
		return val_new;
	else
		return val_old;
}

/*********************************************************************/
void main( int argc, char* argv[] )
{
char c, comm_val;

int op=25, done=FALSE, restart, first, loop=0;
int temp_old=0, temp_new;
int config_old=0, config_new;
int th_old=0, th_new;
int tl_old=0, tl_new;

delay( 0 );

save_screen();

if ( argc >= 2 )
	c = comm_port( argv[1][0] );
else
	c = comm_port( NULL );

if ( c == -1 )
	{
	terminate();
	exit( 0 );
	}

do
	{
	restart = FALSE;
	first = TRUE;
	loop = 0;

	set_up_screen();

	draw_cursor( op, _ON_ );

	do
		{
		while ( !kbhit() && !done && !restart )
			{
			while ( !check_port() && !done && !restart )
				{
				comm_val=comm_switch();
				if ( comm_val=='q' || comm_val=='Q' )
					done = TRUE;
				else
					if ( comm_val=='s' || comm_val=='S' )
						{
						comm_port( NULL );
						restart = TRUE;
						}
					else
						restart = TRUE;
				}

			if ( !done && !restart )
				{
				loop++;
				switch ( loop )
					{
					case 1:	temp_new = read_val( _TEMP_, temp_old );
								if ( ( temp_new != temp_old ) || first )
									thermometer( temp_old=temp_new );
								break;
					case 2:	config_new = read_val( _CONFIG_, config_old );
								if ( ( config_new != config_old ) || first )
									{
									configuration( config_old=config_new );
									draw_cursor( op, _ON_ );
									}
								break;
					case 3:	th_new = read_val( _TH_, th_old );
								if ( ( th_new != th_old ) || first )
									{
									thermostat( _TH_, th_old=th_new );
									draw_cursor( op, _ON_ );
									}
								break;
					case 4:	tl_new = read_val( _TL_, tl_old );
								if ( ( tl_new != tl_old ) || first )
									{
									thermostat( _TL_, tl_old=tl_new );
									draw_cursor( op, _ON_ );
									}
								loop=0;
								first=FALSE;
								break;
					}
				}
			}

		if ( !done && !restart )
			perform_op( &op, &th_new, &tl_new, &config_old, &config_new,
				&done, &restart );
		} while ( !done && !restart );
	} while ( !done );

	terminate();
}